Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.cpp	(revision 1853)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.cpp	(revision 1869)
@@ -660,682 +660,816 @@
   CATCH_DUMP_ATTR
 
+  //----------------------------------------------------------------
+
+  void CField::setRelFile(CFile* _file)
+  TRY
+  {
+    this->file = _file;
+    hasOutputFile = true;
+  }
+  CATCH_DUMP_ATTR
+
+  //----------------------------------------------------------------
+
+  StdString CField::GetName(void)    { return StdString("field"); }
+  StdString CField::GetDefName(void) { return CField::GetName(); }
+  ENodeType CField::GetType(void)    { return eField; }
+
+  //----------------------------------------------------------------
+
+  CGrid* CField::getRelGrid(void) const
+  TRY
+  {
+    return this->grid_;
+  }
+  CATCH
+
+  //----------------------------------------------------------------
+
+  CFile* CField::getRelFile(void) const
+  TRY
+  {
+    return this->file;
+  }
+  CATCH
+
+  int CField::getNStep(void) const
+  TRY
+  {
+    return this->nstep;
+  }
+  CATCH
+
+  func::CFunctor::ETimeType CField::getOperationTimeType() const
+  TRY
+  {
+    return operationTimeType;
+  }
+  CATCH
+
    //----------------------------------------------------------------
 
-   void CField::setRelFile(CFile* _file)
-   TRY
-   {
-      this->file = _file;
-      hasOutputFile = true;
-   }
-   CATCH_DUMP_ATTR
-
-   //----------------------------------------------------------------
-
-   StdString CField::GetName(void)    { return StdString("field"); }
-   StdString CField::GetDefName(void) { return CField::GetName(); }
-   ENodeType CField::GetType(void)    { return eField; }
-
-   //----------------------------------------------------------------
-
-   CGrid* CField::getRelGrid(void) const
-   TRY
-   {
-      return this->grid;
-   }
-   CATCH
-
-   //----------------------------------------------------------------
-
-   CFile* CField::getRelFile(void) const
-   TRY
-   {
-      return this->file;
-   }
-   CATCH
-
-   int CField::getNStep(void) const
-   TRY
-   {
-      return this->nstep;
-   }
-   CATCH
-
-   func::CFunctor::ETimeType CField::getOperationTimeType() const
-   TRY
-   {
-     return operationTimeType;
-   }
-   CATCH
-
-   //----------------------------------------------------------------
-
-   void CField::incrementNStep(void)
-   TRY
-   {
-      this->nstep++;
-   }
-   CATCH_DUMP_ATTR
-
-   void CField::resetNStep(int nstep /*= 0*/)
-   TRY
-   {
-      this->nstep = nstep;
-   }
-   CATCH_DUMP_ATTR
-
-   void CField::resetNStepMax(void)
-   TRY
-   {
-      this->nstepMax = 0;
-      nstepMaxRead = false;
-   }
-   CATCH_DUMP_ATTR
-
-   //----------------------------------------------------------------
-
-   bool CField::isActive(bool atCurrentTimestep /*= false*/) const
-   TRY
-   {
-      if (clientSourceFilter)
-        return atCurrentTimestep ? clientSourceFilter->isDataExpected(CContext::getCurrent()->getCalendar()->getCurrentDate()) : true;
-      else if (storeFilter)
-        return true;
-      else if (instantDataFilter)
-        ERROR("bool CField::isActive(bool atCurrentTimestep)",
-              << "Impossible to check if field [ id = " << getId() << " ] is active as it cannot be used to receive nor send data.");
-
-      return false;
-   }
-   CATCH
-
-   //----------------------------------------------------------------
-
-   bool CField::wasWritten() const
-   TRY
-   {
-     return written;
-   }
-   CATCH
-
-   void CField::setWritten()
-   TRY
-   {
-     written = true;
-   }
-   CATCH_DUMP_ATTR
-
-   //----------------------------------------------------------------
-
-   bool CField::getUseCompressedOutput() const
-   TRY
-   {
-     return useCompressedOutput;
-   }
-   CATCH
-
-   void CField::setUseCompressedOutput()
-   TRY
-   {
-     useCompressedOutput = true;
-   }
-   CATCH_DUMP_ATTR
-
-   //----------------------------------------------------------------
-
-   std::shared_ptr<COutputPin> CField::getInstantDataFilter()
-   TRY
-   {
-     return instantDataFilter;
-   }
-   CATCH_DUMP_ATTR
-
-   //----------------------------------------------------------------
+  void CField::incrementNStep(void)
+  TRY
+  {
+    this->nstep++;
+  }
+  CATCH_DUMP_ATTR
+
+  void CField::resetNStep(int nstep /*= 0*/)
+  TRY
+  {
+    this->nstep = nstep;
+  }
+  CATCH_DUMP_ATTR
+
+  void CField::resetNStepMax(void)
+  TRY
+  {
+    this->nstepMax = 0;
+    nstepMaxRead = false;
+  }
+  CATCH_DUMP_ATTR
+
+  //----------------------------------------------------------------
+
+  bool CField::isActive(bool atCurrentTimestep /*= false*/) const
+  TRY
+  {
+    if (clientSourceFilter)
+      return atCurrentTimestep ? clientSourceFilter->isDataExpected(CContext::getCurrent()->getCalendar()->getCurrentDate()) : true;
+    else if (storeFilter)
+      return true;
+    else if (instantDataFilter)
+      ERROR("bool CField::isActive(bool atCurrentTimestep)",
+            << "Impossible to check if field [ id = " << getId() << " ] is active as it cannot be used to receive nor send data.");
+
+    return false;
+  }
+  CATCH
+
+  //----------------------------------------------------------------
+
+  bool CField::wasWritten() const
+  TRY
+  {
+    return written;
+  }
+  CATCH
+
+  void CField::setWritten()
+  TRY
+  {
+    written = true;
+  }
+  CATCH_DUMP_ATTR
+
+  //----------------------------------------------------------------
+
+  bool CField::getUseCompressedOutput() const
+  TRY
+  {
+    return useCompressedOutput;
+  }
+  CATCH
+
+  void CField::setUseCompressedOutput()
+  TRY
+  {
+    useCompressedOutput = true;
+  }
+  CATCH_DUMP_ATTR
+
+  //----------------------------------------------------------------
+
+  std::shared_ptr<COutputPin> CField::getInstantDataFilter()
+  TRY
+  {
+    return instantDataFilter;
+  }
+  CATCH_DUMP_ATTR
+
+  //----------------------------------------------------------------
+
+  /*!
+    Build up graph of grids which plays role of destination and source in grid transformation
+    This function should be called before \func solveGridReference()
+  */
+  void CField::buildGridTransformationGraph()
+  TRY
+  {
+    CContext* context = CContext::getCurrent();
+    if (context->getServiceType()==CServicesManager::CLIENT)
+    {
+      if (grid_ && !grid_->isTransformed() && hasDirectFieldReference() && grid_ != getDirectFieldReference()->grid_)
+      {
+        grid_->addTransGridSource(getDirectFieldReference()->grid_);
+      }
+    }
+  }
+  CATCH_DUMP_ATTR
+
+  /*!
+    Generate a new grid destination if there are more than one grid source pointing to a same grid destination
+  */
+  void CField::generateNewTransformationGridDest()
+  TRY
+  {
+    CContext* context = CContext::getCurrent();
+    if (context->getServiceType()==CServicesManager::CLIENT)
+    {
+      std::map<CGrid*,std::pair<bool,StdString> >& gridSrcMap = grid_->getTransGridSource();
+      if (1 < gridSrcMap.size())
+      {
+        // Search for grid source
+        CGrid* gridSrc = grid_;
+        CField* currField = this;
+        std::vector<CField*> hieraField;
+        while (currField->hasDirectFieldReference() && (gridSrc == grid_))
+        {
+          hieraField.push_back(currField);
+          CField* tmp = currField->getDirectFieldReference();
+          currField = tmp;
+          gridSrc = currField->grid_;
+        }
+
+        if (gridSrcMap.end() != gridSrcMap.find(gridSrc))
+        {
+          CGrid* gridTmp;
+          std::pair<bool,StdString> newGridDest = gridSrcMap[gridSrc];
+          if (newGridDest.first)
+          {
+            StdString newIdGridDest = newGridDest.second;
+            if (!CGrid::has(newIdGridDest))
+            {
+              ERROR("CGrid* CGrid::generateNewTransformationGridDest()",
+                << " Something wrong happened! Grid whose id " << newIdGridDest
+                << "should exist ");
+            }
+            gridTmp = CGrid::get(newIdGridDest);
+          }
+          else
+          {
+            StdString newIdGridDest = CGrid::generateId(gridSrc, grid_);
+            gridTmp = CGrid::cloneGrid(newIdGridDest, grid_);
+
+            (gridSrcMap[gridSrc]).first = true;
+            (gridSrcMap[gridSrc]).second = newIdGridDest;
+          }
+
+          // Update all descendants
+          for (std::vector<CField*>::iterator it = hieraField.begin(); it != hieraField.end(); ++it)
+          {
+            (*it)->grid_ = gridTmp;
+            (*it)->updateRef((*it)->grid_);
+          }
+        }
+      }
+    }
+  }
+  CATCH_DUMP_ATTR
+
+  void CField::updateRef(CGrid* grid)
+  TRY
+  {
+    if (!grid_ref.isEmpty()) grid_ref.setValue(grid->getId());
+    else
+    {
+      std::vector<CAxis*> axisTmp = grid->getAxis();
+      std::vector<CDomain*> domainTmp = grid->getDomains();
+      if ((1<axisTmp.size()) || (1<domainTmp.size()))
+        ERROR("void CField::updateRef(CGrid* grid)",
+          << "More than one domain or axis is available for domain_ref/axis_ref of field " << this->getId());
+
+      if ((!domain_ref.isEmpty()) && (domainTmp.empty()))
+        ERROR("void CField::updateRef(CGrid* grid)",
+          << "Incoherent between available domain and domain_ref of field " << this->getId());
+      if ((!axis_ref.isEmpty()) && (axisTmp.empty()))
+        ERROR("void CField::updateRef(CGrid* grid)",
+          << "Incoherent between available axis and axis_ref of field " << this->getId());
+
+      if (!domain_ref.isEmpty()) domain_ref.setValue(domainTmp[0]->getId());
+      if (!axis_ref.isEmpty()) axis_ref.setValue(axisTmp[0]->getId());
+    }
+  }
+  CATCH_DUMP_ATTR
+   
+  /*!
+    Solve reference of all enabled fields even the source fields .
+    In this step, we do transformations.
+  */
+  void CField::solveAllEnabledFieldsAndTransform()
+  TRY
+  {
+    CContext* context = CContext::getCurrent();
+
+    if (!isReferenceSolvedAndTransformed)
+    {
+      isReferenceSolvedAndTransformed = true;
+
+      if (context->getServiceType()==CServicesManager::CLIENT)
+      {
+        solveRefInheritance(true);
+        if (hasDirectFieldReference()) getDirectFieldReference()->solveAllEnabledFieldsAndTransform();
+      }
+
+      if (context->getServiceType()==CServicesManager::GATHERER || context->getServiceType()==CServicesManager::OUT_SERVER)
+        solveServerOperation();
+
+      solveGridReference();
+
+      if (context->getServiceType()==CServicesManager::CLIENT)
+      {
+        solveGenerateGrid();
+        buildGridTransformationGraph();
+      }
+
+      solveGridDomainAxisRef(false);
+
+      if (context->getServiceType()==CServicesManager::CLIENT)
+      {
+        solveTransformedGrid();
+      }
+
+      solveGridDomainAxisRef(false);
+    }
+  }
+  CATCH_DUMP_ATTR
+
+  void CField::checkGridOfEnabledFields()
+  TRY
+  {
+    if (!isGridChecked)
+    {
+      isGridChecked = true;
+      solveCheckMaskIndex(false);
+    }
+  }
+  CATCH_DUMP_ATTR
+
+  void CField::sendGridComponentOfEnabledFields()
+  TRY
+  {
+    solveGridDomainAxisRef(true);
+    // solveCheckMaskIndex(true);
+  }
+  CATCH_DUMP_ATTR
+
+  void CField::sendGridOfEnabledFields()
+  TRY
+  {
+    // solveGridDomainAxisRef(true);
+    solveCheckMaskIndex(true);
+  }   
+  CATCH_DUMP_ATTR
+
+  void CField::solveOnlyReferenceEnabledField(void)
+  TRY
+  {
+    CContext* context = CContext::getCurrent();
+    if (!isReferenceSolved)
+    {
+      isReferenceSolved = true;
+
+      if (context->getServiceType()==CServicesManager::CLIENT)
+      {
+        solveRefInheritance(true);
+        if (hasDirectFieldReference()) getDirectFieldReference()->solveOnlyReferenceEnabledField();
+      }
+
+      if (context->getServiceType()==CServicesManager::GATHERER || context->getServiceType()==CServicesManager::OUT_SERVER)
+        solveServerOperation();
+
+      solveGridReference();
+      grid_->solveElementsRefInheritance(true); // make it again to solve grid reading from file
+
+      if (context->getServiceType()==CServicesManager::CLIENT)
+      {
+        solveGenerateGrid();
+        buildGridTransformationGraph();
+      }
+    }
+  }
+  CATCH_DUMP_ATTR
+
+  void CField::solveAllReferenceEnabledField(bool doSending2Server)
+  TRY
+  {
+    CContext* context = CContext::getCurrent();
+    solveOnlyReferenceEnabledField();
+
+    if (!areAllReferenceSolved)
+    {
+      areAllReferenceSolved = true;
+      
+      if (context->getServiceType()==CServicesManager::CLIENT)
+      {
+        solveRefInheritance(true);
+        if (hasDirectFieldReference()) getDirectFieldReference()->solveAllReferenceEnabledField(false);
+      }
+      else if (context->getServiceType()==CServicesManager::GATHERER || context->getServiceType()==CServicesManager::OUT_SERVER)
+        solveServerOperation();
+
+      solveGridReference();
+    }
+
+    solveGridDomainAxisRef(doSending2Server);
+
+    if (context->getServiceType()==CServicesManager::CLIENT)
+    {
+      solveTransformedGrid();
+    }
+
+    solveCheckMaskIndex(doSending2Server);
+  }
+  CATCH_DUMP_ATTR
+
+  std::map<int, StdSize> CField::getGridAttributesBufferSize(CContextClient* client, bool bufferForWriting /*= "false"*/)
+  TRY
+  {
+    return grid_->getAttributesBufferSize(client, bufferForWriting);
+  }
+  CATCH_DUMP_ATTR
+
+  std::map<int, StdSize> CField::getGridDataBufferSize(CContextClient* client, bool bufferForWriting /*= "false"*/)
+  TRY
+  {
+    return grid_->getDataBufferSize(client, getId(), bufferForWriting);
+  }
+  CATCH_DUMP_ATTR
+
+  size_t CField::getGlobalWrittenSize()
+  TRY
+  {
+    return grid_->getGlobalWrittenSize();
+  }
+  CATCH_DUMP_ATTR
+
+  //----------------------------------------------------------------
+
+  void CField::solveServerOperation(void)
+  TRY
+  {
+    CContext* context = CContext::getCurrent();
+
+    if (context->getServiceType()==CServicesManager::CLIENT || !hasOutputFile) return;
+
+    if (freq_op.isEmpty()) freq_op.setValue(TimeStep);
+
+    if (freq_offset.isEmpty()) freq_offset.setValue(NoneDu);
+
+    freq_operation_srv = file->output_freq.getValue();
+    freq_write_srv     = file->output_freq.getValue();
+
+    lastlast_Write_srv = context->getCalendar()->getInitDate();
+    last_Write_srv     = context->getCalendar()->getInitDate();
+    last_operation_srv = context->getCalendar()->getInitDate();
+
+    const CDuration toffset = freq_operation_srv - freq_offset.getValue() - context->getCalendar()->getTimeStep();
+    last_operation_srv     = last_operation_srv - toffset;
+
+    if (operation.isEmpty())
+      ERROR("void CField::solveServerOperation(void)",
+            << "An operation must be defined for field \"" << getId() << "\".");
+
+    std::shared_ptr<func::CFunctor> functor;
+    CArray<double, 1> dummyData;
+
+#define DECLARE_FUNCTOR(MType, mtype) \
+    if (operation.getValue().compare(#mtype) == 0) \
+    { \
+      functor.reset(new func::C##MType(dummyData)); \
+    }
+
+#include "functor_type.conf"
+
+    if (!functor)
+      ERROR("void CField::solveServerOperation(void)",
+            << "\"" << operation << "\" is not a valid operation.");
+
+    operationTimeType = functor->timeType();
+  }
+  CATCH_DUMP_ATTR
+
+ //----------------------------------------------------------------
+
+  bool CField::buildWorkflowGraph(CGarbageCollector& gc)
+  {
+    if (buildWorkflowGraphDone_) return true ;
+    const bool detectMissingValues = (!detect_missing_value.isEmpty() && !default_value.isEmpty() && detect_missing_value == true);
+    const double defaultValue  = detectMissingValues ? default_value : (!default_value.isEmpty() ? default_value : 0.0);
+
+    if (!inputFilter) inputFilter = std::shared_ptr<CPassThroughFilter>(new CPassThroughFilter(gc)); 
+     
+    if (hasDirectFieldReference())
+    {
+      CField* fieldRef = getDirectFieldReference();
+      bool ret=fieldRef->buildWorkflowGraph(gc); 
+      if (!ret) return false ; // workflow graph cannot be built at this stage
+    }
+
+    // Check if we have an expression to parse
+    std::shared_ptr<COutputPin> filterExpr ;
+    if (hasExpression())
+    {
+      boost::scoped_ptr<IFilterExprNode> expr(parseExpr(getExpression() + '\0'));
+      filterExpr = expr->reduce(gc, *this);
+      if (!filterExpr) return false ; // workflow graph cannot be built at this stage
+    }
+    
+    // now construct grid and check if element are enabled
+    solveGridReference() ; // grid_ is now defined
+    
+    // prepare transformation. Need to know before if workflow of auxillary field can be built
+    if (hasDirectFieldReference())
+    {
+      auto gridPath=getGridPath() ;
+      gridPath.push_back(grid_) ;
+
+      CGrid* gridSrc=getDirectFieldReference()->getGrid() ;
+      for(auto grid : gridPath)
+      {
+        if (!grid->checkIfCompleted()) return false ;
+        grid->solveElementsRefInheritance() ;
+        grid_->completeGrid(gridSrc); // grid generation, to be checked
+        grid->prepareTransformGrid(gridSrc) ; // prepare the grid tranformation
+        for(auto fieldId : grid->getAuxInputTransformGrid()) // try to build workflow graph for auxillary field tranformation
+          if (!CField::get(fieldId)->buildWorkflowGraph(gc)) return false ;
+        gridSrc=grid ;
+      }
+      
+      std::shared_ptr<COutputPin> lastFilter ;
+      if (filterExpr) lastFilter=filterExpr ;
+      else lastFilter = inputFilter ;
+      
+      gridSrc=getDirectFieldReference()->getGrid() ;
+      for(auto grid : gridPath) 
+      {
+        grid->makeTransformGrid() ; // make the grid transformation
+        std::pair<std::shared_ptr<CFilter>, std::shared_ptr<CFilter> > filters = CSpatialTransformFilter::buildFilterGraph(gc, gridSrc, grid, detectMissingValues, defaultValue); 
+        lastFilter->connectOutput(filters.first, 0);
+        lastFilter = filters.second;
+        gridSrc=grid ;
+      }
+      instantDataFilter = lastFilter ;
+      
+      // connect the input Filter to the reference
+      getDirectFieldReference()->getInstantDataFilter()->connectOutput(inputFilter,0);
+    }
+    else 
+    {
+      if (!grid_->checkIfCompleted()) return false ;
+      grid_->solveElementsRefInheritance() ;
+      grid_->completeGrid(); // grid generation, to be checked
+      grid_->checkElementsAttributes() ;
+      instantDataFilter=inputFilter ;
+      setModelIn() ; // no reference, the field is potentially a source field from model
+    }
+    
+    buildWorkflowGraphDone_ = true ;
+    workflowEnabled_ = true ;
+    return true ;
+  }
+   
+  
+  void CField::connectToFileServer(CGarbageCollector& gc)
+  {
+    // insert temporal filter before sending to files
+    fileWriterFilter = std::shared_ptr<CFileWriterFilter>(new CFileWriterFilter(gc, this, file->getContextClient()));
+    // insert temporal filter before sending to files
+    getTemporalDataFilter(gc, file->output_freq)->connectOutput(fileWriterFilter, 0);
+  } 
+
+  void CField::computeGridIndexToFileServer(void)
+  {
+    grid_->computeGridIndexToFileServer(client) ;
+  }
 
    /*!
-     Build up graph of grids which plays role of destination and source in grid transformation
-     This function should be called before \func solveGridReference()
+   * Transform the grid_path attribut into vector of grid.
+   * \return the vector CGrid* containing the list of grid path for tranformation
+   */ 
+  vector<CGrid*> CField::getGridPath(void)
+  {
+    std::vector<CGrid*> gridPath;
+
+    if (hasDirectFieldReference() && grid_ != getDirectFieldReference()->grid_)
+    {
+      if (!grid_path.isEmpty())
+      {
+        std::string gridId;
+        size_t start = 0, end;
+
+        do
+        {
+          end = grid_path.getValue().find(',', start);
+          if (end != std::string::npos)
+          {
+            gridId = grid_path.getValue().substr(start, end - start);
+            start = end + 1;
+          }
+          else gridId = grid_path.getValue().substr(start);
+
+          if (!CGrid::has(gridId))
+            ERROR("void CField::solveTransformedGrid()",
+               << "Invalid grid_path, the grid '" << gridId << "' does not exist.");
+
+          gridPath.push_back(CGrid::get(gridId));
+        }
+        while (end != std::string::npos);
+      }
+    }
+    return gridPath ;
+  }
+
+  /*!
+   * Constructs the graph filter for the field, enabling or not the data output.
+   * This method should not be called more than once with enableOutput equal to true.
+   *
+   * \param gc the garbage collector to use when building the filter graph
+   * \param enableOutput must be true when the field data is to be
+   *                     read by the client or/and written to a file
    */
-   void CField::buildGridTransformationGraph()
-   TRY
-   {
-     CContext* context = CContext::getCurrent();
-     if (context->getServiceType()==CServicesManager::CLIENT)
-     {
-       if (grid && !grid->isTransformed() && hasDirectFieldReference() && grid != getDirectFieldReference()->grid)
-       {
-         grid->addTransGridSource(getDirectFieldReference()->grid);
-       }
-     }
-   }
-   CATCH_DUMP_ATTR
-
-   /*!
-     Generate a new grid destination if there are more than one grid source pointing to a same grid destination
-   */
-   void CField::generateNewTransformationGridDest()
-   TRY
-   {
-     CContext* context = CContext::getCurrent();
-     if (context->getServiceType()==CServicesManager::CLIENT)
-     {
-       std::map<CGrid*,std::pair<bool,StdString> >& gridSrcMap = grid->getTransGridSource();
-       if (1 < gridSrcMap.size())
-       {
-         // Search for grid source
-         CGrid* gridSrc = grid;
-         CField* currField = this;
-         std::vector<CField*> hieraField;
-
-         while (currField->hasDirectFieldReference() && (gridSrc == grid))
-         {
-           hieraField.push_back(currField);
-           CField* tmp = currField->getDirectFieldReference();
-           currField = tmp;
-           gridSrc = currField->grid;
-         }
-
-         if (gridSrcMap.end() != gridSrcMap.find(gridSrc))
-         {
-           CGrid* gridTmp;
-           std::pair<bool,StdString> newGridDest = gridSrcMap[gridSrc];
-           if (newGridDest.first)
-           {
-             StdString newIdGridDest = newGridDest.second;
-             if (!CGrid::has(newIdGridDest))
-             {
-                ERROR("CGrid* CGrid::generateNewTransformationGridDest()",
-                  << " Something wrong happened! Grid whose id " << newIdGridDest
-                  << "should exist ");
-             }
-             gridTmp = CGrid::get(newIdGridDest);
-           }
-           else
-           {
-             StdString newIdGridDest = CGrid::generateId(gridSrc, grid);
-             gridTmp = CGrid::cloneGrid(newIdGridDest, grid);
-
-             (gridSrcMap[gridSrc]).first = true;
-             (gridSrcMap[gridSrc]).second = newIdGridDest;
-           }
-
-           // Update all descendants
-           for (std::vector<CField*>::iterator it = hieraField.begin(); it != hieraField.end(); ++it)
-           {
-             (*it)->grid = gridTmp;
-             (*it)->updateRef((*it)->grid);
-           }
-         }
-       }
-     }
-   }
-   CATCH_DUMP_ATTR
-
-   void CField::updateRef(CGrid* grid)
-   TRY
-   {
-     if (!grid_ref.isEmpty()) grid_ref.setValue(grid->getId());
-     else
-     {
-       std::vector<CAxis*> axisTmp = grid->getAxis();
-       std::vector<CDomain*> domainTmp = grid->getDomains();
-       if ((1<axisTmp.size()) || (1<domainTmp.size()))
-         ERROR("void CField::updateRef(CGrid* grid)",
-           << "More than one domain or axis is available for domain_ref/axis_ref of field " << this->getId());
-
-       if ((!domain_ref.isEmpty()) && (domainTmp.empty()))
-         ERROR("void CField::updateRef(CGrid* grid)",
-           << "Incoherent between available domain and domain_ref of field " << this->getId());
-       if ((!axis_ref.isEmpty()) && (axisTmp.empty()))
-         ERROR("void CField::updateRef(CGrid* grid)",
-           << "Incoherent between available axis and axis_ref of field " << this->getId());
-
-       if (!domain_ref.isEmpty()) domain_ref.setValue(domainTmp[0]->getId());
-       if (!axis_ref.isEmpty()) axis_ref.setValue(axisTmp[0]->getId());
-     }
-   }
-   CATCH_DUMP_ATTR
-   
-   /*!
-     Solve reference of all enabled fields even the source fields .
-     In this step, we do transformations.
-   */
-   void CField::solveAllEnabledFieldsAndTransform()
-   TRY
-   {
-     CContext* context = CContext::getCurrent();
-
-     if (!isReferenceSolvedAndTransformed)
-     {
-        isReferenceSolvedAndTransformed = true;
-
-        if (context->getServiceType()==CServicesManager::CLIENT)
-        {
-          solveRefInheritance(true);
-          if (hasDirectFieldReference()) getDirectFieldReference()->solveAllEnabledFieldsAndTransform();
-        }
-
-        if (context->getServiceType()==CServicesManager::GATHERER || context->getServiceType()==CServicesManager::OUT_SERVER)
-          solveServerOperation();
-
-        solveGridReference();
-
-       if (context->getServiceType()==CServicesManager::CLIENT)
-       {
-         solveGenerateGrid();
-         buildGridTransformationGraph();
-       }
-
-       solveGridDomainAxisRef(false);
-
-       if (context->getServiceType()==CServicesManager::CLIENT)
-       {
-         solveTransformedGrid();
-       }
-
-       solveGridDomainAxisRef(false);
-     }
-   }
-   CATCH_DUMP_ATTR
-
-   void CField::checkGridOfEnabledFields()
-   TRY
-   {
-     if (!isGridChecked)
-     {
-       isGridChecked = true;
-       solveCheckMaskIndex(false);
-     }
-   }
-   CATCH_DUMP_ATTR
-
-   void CField::sendGridComponentOfEnabledFields()
-   TRY
-   {
-      solveGridDomainAxisRef(true);
-      // solveCheckMaskIndex(true);
-   }
-   CATCH_DUMP_ATTR
-
-   void CField::sendGridOfEnabledFields()
-   TRY
-   {
-      // solveGridDomainAxisRef(true);
-      solveCheckMaskIndex(true);
-   }   
-   CATCH_DUMP_ATTR
-
-   void CField::solveOnlyReferenceEnabledField(void)
-   TRY
-   {
-     CContext* context = CContext::getCurrent();
-     if (!isReferenceSolved)
-     {
-        isReferenceSolved = true;
-
-        if (context->getServiceType()==CServicesManager::CLIENT)
-        {
-          solveRefInheritance(true);
-          if (hasDirectFieldReference()) getDirectFieldReference()->solveOnlyReferenceEnabledField();
-        }
-
-        if (context->getServiceType()==CServicesManager::GATHERER || context->getServiceType()==CServicesManager::OUT_SERVER)
-          solveServerOperation();
-
-        solveGridReference();
-        grid->solveDomainAxisRefInheritance(true); // make it again to solve grid reading from file
-
-       if (context->getServiceType()==CServicesManager::CLIENT)
-       {
-         solveGenerateGrid();
-         buildGridTransformationGraph();
-       }
-     }
-   }
-   CATCH_DUMP_ATTR
-
-   void CField::solveAllReferenceEnabledField(bool doSending2Server)
-   TRY
-   {
-     CContext* context = CContext::getCurrent();
-     solveOnlyReferenceEnabledField();
-
-     if (!areAllReferenceSolved)
-     {
-        areAllReferenceSolved = true;
-       
-        if (context->getServiceType()==CServicesManager::CLIENT)
-        {
-          solveRefInheritance(true);
-          if (hasDirectFieldReference()) getDirectFieldReference()->solveAllReferenceEnabledField(false);
-        }
-        else if (context->getServiceType()==CServicesManager::GATHERER || context->getServiceType()==CServicesManager::OUT_SERVER)
-          solveServerOperation();
-
-        solveGridReference();
-     }
-
-     solveGridDomainAxisRef(doSending2Server);
-
-     if (context->getServiceType()==CServicesManager::CLIENT)
-     {
-       solveTransformedGrid();
-     }
-
-     solveCheckMaskIndex(doSending2Server);
-   }
-   CATCH_DUMP_ATTR
-
-   std::map<int, StdSize> CField::getGridAttributesBufferSize(CContextClient* client, bool bufferForWriting /*= "false"*/)
-   TRY
-   {
-     return grid->getAttributesBufferSize(client, bufferForWriting);
-   }
-   CATCH_DUMP_ATTR
-
-   std::map<int, StdSize> CField::getGridDataBufferSize(CContextClient* client, bool bufferForWriting /*= "false"*/)
-   TRY
-   {
-     return grid->getDataBufferSize(client, getId(), bufferForWriting);
-   }
-   CATCH_DUMP_ATTR
-
-   size_t CField::getGlobalWrittenSize()
-   TRY
-   {
-     return grid->getGlobalWrittenSize();
-   }
-   CATCH_DUMP_ATTR
-
-   //----------------------------------------------------------------
-
-   void CField::solveServerOperation(void)
-   TRY
-   {
-      CContext* context = CContext::getCurrent();
-
-      if (context->getServiceType()==CServicesManager::CLIENT || !hasOutputFile) return;
-
-      if (freq_op.isEmpty())
-        freq_op.setValue(TimeStep);
-
-      if (freq_offset.isEmpty())
-        freq_offset.setValue(NoneDu);
-
-      freq_operation_srv = file->output_freq.getValue();
-      freq_write_srv     = file->output_freq.getValue();
-
-      lastlast_Write_srv = context->getCalendar()->getInitDate();
-      last_Write_srv     = context->getCalendar()->getInitDate();
-      last_operation_srv = context->getCalendar()->getInitDate();
-
-      const CDuration toffset = freq_operation_srv - freq_offset.getValue() - context->getCalendar()->getTimeStep();
-      last_operation_srv     = last_operation_srv - toffset;
-
-      if (operation.isEmpty())
-        ERROR("void CField::solveServerOperation(void)",
-              << "An operation must be defined for field \"" << getId() << "\".");
-
-      std::shared_ptr<func::CFunctor> functor;
-      CArray<double, 1> dummyData;
-
-#define DECLARE_FUNCTOR(MType, mtype) \
-      if (operation.getValue().compare(#mtype) == 0) \
-      { \
-        functor.reset(new func::C##MType(dummyData)); \
-      }
-
-#include "functor_type.conf"
-
-      if (!functor)
-        ERROR("void CField::solveServerOperation(void)",
-              << "\"" << operation << "\" is not a valid operation.");
-
-      operationTimeType = functor->timeType();
-   }
-   CATCH_DUMP_ATTR
-
-   //----------------------------------------------------------------
-
-   /*!
-    * Constructs the graph filter for the field, enabling or not the data output.
-    * This method should not be called more than once with enableOutput equal to true.
-    *
-    * \param gc the garbage collector to use when building the filter graph
-    * \param enableOutput must be true when the field data is to be
-    *                     read by the client or/and written to a file
-    */
-   void CField::buildFilterGraph(CGarbageCollector& gc, bool enableOutput)
-   TRY
-   {     
+
+  void CField::buildFilterGraph(CGarbageCollector& gc, bool enableOutput)
+  TRY
+  {     
     if (!isReferenceSolvedAndTransformed) solveAllEnabledFieldsAndTransform();
     if (!isGridChecked) checkGridOfEnabledFields();
 
-     const bool detectMissingValues = (!detect_missing_value.isEmpty() && !default_value.isEmpty() && detect_missing_value == true);
-     const double defaultValue  = detectMissingValues ? default_value : (!default_value.isEmpty() ? default_value : 0.0);
-
-     CContext* context = CContext::getCurrent();
-     bool hasWriterServer = context->getServiceType()==CServicesManager::OUT_SERVER ;
-     bool hasIntermediateServer = context->getServiceType()==CServicesManager::GATHERER ;
-
-     if (hasWriterServer)
-     {
-        if (!instantDataFilter)
-          instantDataFilter = clientSourceFilter = std::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid, true, false));
-
-
-       // If the field data is to be read by the client or/and written to a file
-       if (enableOutput && !storeFilter && !fileWriterFilter)
-       {
-         if (file && (file->mode.isEmpty() || file->mode == CFile::mode_attr::write))
-         {
-           fileServerWriterFilter = std::shared_ptr<CFileServerWriterFilter>(new CFileServerWriterFilter(gc, this));
-           instantDataFilter->connectOutput(fileServerWriterFilter, 0);
+    const bool detectMissingValues = (!detect_missing_value.isEmpty() && !default_value.isEmpty() && detect_missing_value == true);
+    const double defaultValue  = detectMissingValues ? default_value : (!default_value.isEmpty() ? default_value : 0.0);
+
+    CContext* context = CContext::getCurrent();
+    bool hasWriterServer = context->getServiceType()==CServicesManager::OUT_SERVER ;
+    bool hasIntermediateServer = context->getServiceType()==CServicesManager::GATHERER ;
+
+    if (hasWriterServer)
+    {
+      if (!instantDataFilter)
+        instantDataFilter = clientSourceFilter = std::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid_, true, false));
+
+
+      // If the field data is to be read by the client or/and written to a file
+      if (enableOutput && !storeFilter && !fileWriterFilter)
+      {
+        if (file && (file->mode.isEmpty() || file->mode == CFile::mode_attr::write))
+        {
+          fileServerWriterFilter = std::shared_ptr<CFileServerWriterFilter>(new CFileServerWriterFilter(gc, this));
+          instantDataFilter->connectOutput(fileServerWriterFilter, 0);
+        }
+      }
+    }
+    else if (hasIntermediateServer)
+    {
+      if (!instantDataFilter)
+        instantDataFilter = clientSourceFilter = std::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid_, false, false));
+
+      // If the field data is to be read by the client or/and written to a file
+      if (enableOutput && !storeFilter && !fileWriterFilter)
+      {
+        if (file && (file->mode.isEmpty() || file->mode == CFile::mode_attr::write))
+        {
+          fileWriterFilter = std::shared_ptr<CFileWriterFilter>(new CFileWriterFilter(gc, this, file->getContextClient()));
+          instantDataFilter->connectOutput(fileWriterFilter, 0);
+        }
+      }
+    }
+    else
+    {
+      // Start by building a filter which can provide the field's instant data
+      if (!instantDataFilter)
+      {
+        // Check if we have an expression to parse
+        if (hasExpression())
+        {
+          boost::scoped_ptr<IFilterExprNode> expr(parseExpr(getExpression() + '\0'));
+          std::shared_ptr<COutputPin> filter = expr->reduce(gc, *this);
+
+          // Check if a spatial transformation is needed
+          if (!field_ref.isEmpty())
+          {
+            CGrid* gridRef = CField::get(field_ref)->grid_;
+            if (grid_ && grid_ != gridRef && grid_->hasTransform())
+            {
+                std::pair<std::shared_ptr<CFilter>, std::shared_ptr<CFilter> > filters = CSpatialTransformFilter::buildFilterGraph(gc, gridRef, grid_, detectMissingValues, defaultValue); 
+
+              filter->connectOutput(filters.first, 0);
+              filter = filters.second;
+            }
+          }
+
+          instantDataFilter = filter;
+        }
+        // Check if we have a reference on another field
+        else if (!field_ref.isEmpty()) instantDataFilter = getFieldReference(gc);
+        // Check if the data is to be read from a file
+        else if (file && !file->mode.isEmpty() && file->mode == CFile::mode_attr::read)
+        {
+          checkTimeAttributes();
+          instantDataFilter = serverSourceFilter = std::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid_, true, false, freq_offset, true,
+                                                                                                       detectMissingValues, defaultValue));
+        }
+        else // The data might be passed from the model
+        {
+          if (check_if_active.isEmpty()) check_if_active = false; 
+          instantDataFilter = clientSourceFilter = std::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid_, false, true, NoneDu, false,
+                                                                                                      detectMissingValues, defaultValue));
+        }
+      }
+
+      // If the field data is to be read by the client or/and written to a file
+      if (enableOutput && !storeFilter && !fileWriterFilter)
+      {
+        if (!read_access.isEmpty() && read_access)
+        {
+          storeFilter = std::shared_ptr<CStoreFilter>(new CStoreFilter(gc, CContext::getCurrent(), grid_,
+                                                                          detectMissingValues, defaultValue));
+          instantDataFilter->connectOutput(storeFilter, 0);
+        }
+
+        if (file && (file->mode.isEmpty() || file->mode == CFile::mode_attr::write))
+        {
+          fileWriterFilter = std::shared_ptr<CFileWriterFilter>(new CFileWriterFilter(gc, this, file->getContextClient()));
+          getTemporalDataFilter(gc, file->output_freq)->connectOutput(fileWriterFilter, 0);
+        }
+      }
+    }
+  }
+  CATCH_DUMP_ATTR
+
+  /*!
+   * Returns the filter needed to handle the field reference.
+   * This method should only be called when building the filter graph corresponding to the field.
+   *
+   * \param gc the garbage collector to use
+   * \return the output pin corresponding to the field reference
+   */
+  std::shared_ptr<COutputPin> CField::getFieldReference(CGarbageCollector& gc)
+  TRY
+  {
+    if (instantDataFilter || field_ref.isEmpty())
+      ERROR("COutputPin* CField::getFieldReference(CGarbageCollector& gc)",
+            "Impossible to get the field reference for a field which has already been parsed or which does not have a field_ref.");
+
+    CField* fieldRef = CField::get(field_ref);
+    fieldRef->buildFilterGraph(gc, false);
+
+    std::pair<std::shared_ptr<CFilter>, std::shared_ptr<CFilter> > filters;
+    // Check if a spatial transformation is needed
+    if (grid_ && grid_ != fieldRef->grid_ && grid_->hasTransform())
+    {       
+      bool hasMissingValue = (!detect_missing_value.isEmpty() && !default_value.isEmpty() && detect_missing_value == true);
+      double defaultValue  = hasMissingValue ? default_value : (!default_value.isEmpty() ? default_value : 0.0);                                
+      filters = CSpatialTransformFilter::buildFilterGraph(gc, fieldRef->grid_, grid_, hasMissingValue, defaultValue);
+    }
+    else
+      filters.first = filters.second = std::shared_ptr<CFilter>(new CPassThroughFilter(gc));
+
+    fieldRef->getInstantDataFilter()->connectOutput(filters.first, 0);
+
+    return filters.second;
+  }
+  CATCH_DUMP_ATTR
+
+  /*!
+   * Returns the filter needed to handle a self reference in the field's expression.
+   * If the needed filter does not exist, it is created, otherwise it is reused.
+   * This method should only be called when building the filter graph corresponding
+   * to the field's expression.
+   *
+   * \param gc the garbage collector to use
+   * \return the output pin corresponding to a self reference
+   */
+
+/* old version
+  std::shared_ptr<COutputPin> CField::getSelfReference(CGarbageCollector& gc)
+  TRY
+  {
+    if (instantDataFilter || !hasExpression())
+      ERROR("COutputPin* CField::getSelfReference(CGarbageCollector& gc)",
+            "Impossible to add a self reference to a field which has already been parsed or which does not have an expression.");
+
+    if (!selfReferenceFilter)
+    {
+      const bool detectMissingValues = (!detect_missing_value.isEmpty() && !default_value.isEmpty() && detect_missing_value == true);
+      const double defaultValue  = detectMissingValues ? default_value : (!default_value.isEmpty() ? default_value : 0.0);
+
+      if (file && !file->mode.isEmpty() && file->mode == CFile::mode_attr::read)
+      {
+        if (!serverSourceFilter)
+        {
+          checkTimeAttributes();
+          serverSourceFilter = std::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid_, true, false, freq_offset, true,
+                                                              detectMissingValues, defaultValue));
          }
-       }
-     }
-     else if (hasIntermediateServer)
-     {
-       if (!instantDataFilter)
-         instantDataFilter = clientSourceFilter = std::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid, false, false));
-
-             // If the field data is to be read by the client or/and written to a file
-       if (enableOutput && !storeFilter && !fileWriterFilter)
-       {
-         if (file && (file->mode.isEmpty() || file->mode == CFile::mode_attr::write))
-         {
-           fileWriterFilter = std::shared_ptr<CFileWriterFilter>(new CFileWriterFilter(gc, this, file->getContextClient()));
-           instantDataFilter->connectOutput(fileWriterFilter, 0);
-         }
-       }
-     }
-     else
-     {
-       // Start by building a filter which can provide the field's instant data
-       if (!instantDataFilter)
-       {
-         // Check if we have an expression to parse
-         if (hasExpression())
-         {
-           boost::scoped_ptr<IFilterExprNode> expr(parseExpr(getExpression() + '\0'));
-           std::shared_ptr<COutputPin> filter = expr->reduce(gc, *this);
-
-           // Check if a spatial transformation is needed
-           if (!field_ref.isEmpty())
-           {
-             CGrid* gridRef = CField::get(field_ref)->grid;
-
-             if (grid && grid != gridRef && grid->hasTransform())
-             {
-                 std::pair<std::shared_ptr<CFilter>, std::shared_ptr<CFilter> > filters = CSpatialTransformFilter::buildFilterGraph(gc, gridRef, grid, detectMissingValues, defaultValue); 
-
-               filter->connectOutput(filters.first, 0);
-               filter = filters.second;
-             }
-           }
-
-           instantDataFilter = filter;
-         }
-         // Check if we have a reference on another field
-         else if (!field_ref.isEmpty())
-           instantDataFilter = getFieldReference(gc);
-         // Check if the data is to be read from a file
-         else if (file && !file->mode.isEmpty() && file->mode == CFile::mode_attr::read)
-         {
-           checkTimeAttributes();
-           instantDataFilter = serverSourceFilter = std::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid, true, false, freq_offset, true,
-                                                                                                       detectMissingValues, defaultValue));
-         }
-         else // The data might be passed from the model
-         {
-            if (check_if_active.isEmpty()) check_if_active = false; 
-            instantDataFilter = clientSourceFilter = std::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid, false, true, NoneDu, false,
-                                                                                                        detectMissingValues, defaultValue));
-         }
-       }
-
-       // If the field data is to be read by the client or/and written to a file
-       if (enableOutput && !storeFilter && !fileWriterFilter)
-       {
-         if (!read_access.isEmpty() && read_access)
-         {
-           storeFilter = std::shared_ptr<CStoreFilter>(new CStoreFilter(gc, CContext::getCurrent(), grid,
-                                                                          detectMissingValues, defaultValue));
-           instantDataFilter->connectOutput(storeFilter, 0);
-         }
-
-         if (file && (file->mode.isEmpty() || file->mode == CFile::mode_attr::write))
-         {
-           fileWriterFilter = std::shared_ptr<CFileWriterFilter>(new CFileWriterFilter(gc, this, file->getContextClient()));
-           getTemporalDataFilter(gc, file->output_freq)->connectOutput(fileWriterFilter, 0);
-         }
-       }
-     }
-   }
-   CATCH_DUMP_ATTR
-
-   /*!
-    * Returns the filter needed to handle the field reference.
-    * This method should only be called when building the filter graph corresponding to the field.
-    *
-    * \param gc the garbage collector to use
-    * \return the output pin corresponding to the field reference
-    */
-   std::shared_ptr<COutputPin> CField::getFieldReference(CGarbageCollector& gc)
-   TRY
-   {
-     if (instantDataFilter || field_ref.isEmpty())
-       ERROR("COutputPin* CField::getFieldReference(CGarbageCollector& gc)",
-             "Impossible to get the field reference for a field which has already been parsed or which does not have a field_ref.");
-
-     CField* fieldRef = CField::get(field_ref);
-     fieldRef->buildFilterGraph(gc, false);
-
-     std::pair<std::shared_ptr<CFilter>, std::shared_ptr<CFilter> > filters;
-     // Check if a spatial transformation is needed
-     if (grid && grid != fieldRef->grid && grid->hasTransform())
-     {       
-       bool hasMissingValue = (!detect_missing_value.isEmpty() && !default_value.isEmpty() && detect_missing_value == true);
-       double defaultValue  = hasMissingValue ? default_value : (!default_value.isEmpty() ? default_value : 0.0);                                
-       filters = CSpatialTransformFilter::buildFilterGraph(gc, fieldRef->grid, grid, hasMissingValue, defaultValue);
-     }
-     else
-       filters.first = filters.second = std::shared_ptr<CFilter>(new CPassThroughFilter(gc));
-
-     fieldRef->getInstantDataFilter()->connectOutput(filters.first, 0);
-
-     return filters.second;
-   }
-   CATCH_DUMP_ATTR
-
-   /*!
-    * Returns the filter needed to handle a self reference in the field's expression.
-    * If the needed filter does not exist, it is created, otherwise it is reused.
-    * This method should only be called when building the filter graph corresponding
-    * to the field's expression.
-    *
-    * \param gc the garbage collector to use
-    * \return the output pin corresponding to a self reference
-    */
-   std::shared_ptr<COutputPin> CField::getSelfReference(CGarbageCollector& gc)
-   TRY
-   {
-     if (instantDataFilter || !hasExpression())
-       ERROR("COutputPin* CField::getSelfReference(CGarbageCollector& gc)",
-             "Impossible to add a self reference to a field which has already been parsed or which does not have an expression.");
-
-     if (!selfReferenceFilter)
-     {
-       const bool detectMissingValues = (!detect_missing_value.isEmpty() && !default_value.isEmpty() && detect_missing_value == true);
-       const double defaultValue  = detectMissingValues ? default_value : (!default_value.isEmpty() ? default_value : 0.0);
-
-       if (file && !file->mode.isEmpty() && file->mode == CFile::mode_attr::read)
-       {
-         if (!serverSourceFilter)
-         {
-           checkTimeAttributes();
-           serverSourceFilter = std::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid, true, false, freq_offset, true,
-                                                                                   detectMissingValues, defaultValue));
-         }
-
-         selfReferenceFilter = serverSourceFilter;
-       }
-       else if (!field_ref.isEmpty())
-       {
-         CField* fieldRef = CField::get(field_ref);
-         fieldRef->buildFilterGraph(gc, false);
-         selfReferenceFilter = fieldRef->getInstantDataFilter();
-       }
-       else
-       {
-         if (!clientSourceFilter)
-         {
-           if (check_if_active.isEmpty()) check_if_active = false;
-           clientSourceFilter = std::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid, true, true, NoneDu, false,
-                                                                                   detectMissingValues, defaultValue));
-         }
-
-         selfReferenceFilter = clientSourceFilter;
-       }
-     }
-
-     return selfReferenceFilter;
-   }
-   CATCH_DUMP_ATTR
-
-   /*!
-    * Returns the temporal filter corresponding to the field's temporal operation
-    * for the specified operation frequency. The filter is created if it does not
-    * exist, otherwise it is reused.
-    *
-    * \param gc the garbage collector to use
-    * \param outFreq the operation frequency, i.e. the frequency at which the output data will be computed
-    * \return the output pin corresponding to the requested temporal filter
-    */
-   std::shared_ptr<COutputPin> CField::getTemporalDataFilter(CGarbageCollector& gc, CDuration outFreq)
-   TRY
-   {
-     std::map<CDuration, std::shared_ptr<COutputPin> >::iterator it = temporalDataFilters.find(outFreq);
-
-     if (it == temporalDataFilters.end())
-     {
-       if (operation.isEmpty())
-         ERROR("void CField::getTemporalDataFilter(CGarbageCollector& gc, CDuration outFreq)",
-               << "An operation must be defined for field \"" << getId() << "\".");
-
-       checkTimeAttributes(&outFreq);
-
-       const bool detectMissingValues = (!detect_missing_value.isEmpty()  && detect_missing_value == true);
-       std::shared_ptr<CTemporalFilter> temporalFilter(new CTemporalFilter(gc, operation,
+
+        selfReferenceFilter = serverSourceFilter;
+      }
+      else if (!field_ref.isEmpty())
+      {
+        CField* fieldRef = CField::get(field_ref);
+        fieldRef->buildFilterGraph(gc, false);
+        selfReferenceFilter = fieldRef->getInstantDataFilter();
+      }
+      else
+      {
+        if (!clientSourceFilter)
+        {
+          if (check_if_active.isEmpty()) check_if_active = false;
+          clientSourceFilter = std::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid_, true, true, NoneDu, false,
+                                                                                detectMissingValues, defaultValue));
+        }
+
+        selfReferenceFilter = clientSourceFilter;
+      }
+    }
+
+    return selfReferenceFilter;
+  }
+  CATCH_DUMP_ATTR
+*/
+  std::shared_ptr<COutputPin> CField::getSelfReference(CGarbageCollector& gc)
+  TRY
+  {
+    return inputFilter ;
+  } 
+  CATCH_DUMP_ATTR
+
+  /*!
+   * Returns the temporal filter corresponding to the field's temporal operation
+   * for the specified operation frequency. The filter is created if it does not
+   * exist, otherwise it is reused.
+   *
+   * \param gc the garbage collector to use
+   * \param outFreq the operation frequency, i.e. the frequency at which the output data will be computed
+   * \return the output pin corresponding to the requested temporal filter
+   */
+  std::shared_ptr<COutputPin> CField::getTemporalDataFilter(CGarbageCollector& gc, CDuration outFreq)
+  TRY
+  {
+    std::map<CDuration, std::shared_ptr<COutputPin> >::iterator it = temporalDataFilters.find(outFreq);
+
+    if (it == temporalDataFilters.end())
+    {
+      if (operation.isEmpty())
+        ERROR("void CField::getTemporalDataFilter(CGarbageCollector& gc, CDuration outFreq)",
+              << "An operation must be defined for field \"" << getId() << "\".");
+
+      checkTimeAttributes(&outFreq);
+
+      const bool detectMissingValues = (!detect_missing_value.isEmpty()  && detect_missing_value == true);
+      std::shared_ptr<CTemporalFilter> temporalFilter(new CTemporalFilter(gc, operation,
                                                                              CContext::getCurrent()->getCalendar()->getInitDate(),
                                                                              freq_op, freq_offset, outFreq, detectMissingValues));
 
-       instantDataFilter->connectOutput(temporalFilter, 0);
-
-       it = temporalDataFilters.insert(std::make_pair(outFreq, temporalFilter)).first;
-     }
-
-     return it->second;
-   }
-   CATCH_DUMP_ATTR
+      instantDataFilter->connectOutput(temporalFilter, 0);
+
+      it = temporalDataFilters.insert(std::make_pair(outFreq, temporalFilter)).first;
+    }
+
+    return it->second;
+  }
+  CATCH_DUMP_ATTR
 
   /*!
